-- Time-stamp: <Sat Nov 23 1996 01:25:19 Stardate: [-31]8465.29 hwloidl>
--
-- parfact
-- parallel version of a factorial-like function (i.e. divide-and-conquer)
-- This version has been used in the PLDI'96 paper on GUM to measure
-- the runtime with varying granularity (using explicit cut-offs)
-----------------------------------------------------------------------------

module Main(main) where

import Parallel

pfc :: Int -> Int -> Int -> Int
pfc x y c
   | y - x > c = f1 `par` 
                 (f2 `seq` (f1+f2))
   | x == y    = x
   | otherwise = pf x m + pf (m+1) y
   where
      m  = (x+y) `div` 2
      f1 = pfc x m c
      f2 = pfc (m+1) y c

pf :: Int -> Int -> Int
pf x y
   | x < y     = pf x m + pf (m+1) y
   | otherwise = x
   where
      m  = (x+y) `div` 2

parfact x c = pfc 1 x c

main
 =  let x = 8399608
        c = 8192
    in print (parfact x c)
